"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.P2PCommunicationClient = void 0;
var sodium = __importStar(require("libsodium-wrappers"));
var bignumber_js_1 = __importDefault(require("bignumber.js"));
var crypto_1 = require("../../utils/crypto");
var MatrixClient_1 = require("../../matrix-client/MatrixClient");
var MatrixClientEvent_1 = require("../../matrix-client/models/MatrixClientEvent");
var MatrixMessage_1 = require("../../matrix-client/models/MatrixMessage");
var __1 = require("../..");
var constants_1 = require("../../constants");
var generate_uuid_1 = require("../../utils/generate-uuid");
var get_sender_id_1 = require("../../utils/get-sender-id");
var Logger_1 = require("../../utils/Logger");
var CommunicationClient_1 = require("./CommunicationClient");
var logger = new Logger_1.Logger('P2PCommunicationClient');
var KNOWN_RELAY_SERVERS = [
    'matrix.papers.tech'
    // 'matrix.tez.ie',
    // 'matrix-dev.papers.tech',
    // "matrix.stove-labs.com",
    // "yadayada.cryptonomic-infra.tech"
];
var P2PCommunicationClient = /** @class */ (function (_super) {
    __extends(P2PCommunicationClient, _super);
    function P2PCommunicationClient(name, keyPair, replicationCount, storage, matrixNodes, iconUrl, appUrl) {
        var _this = _super.call(this, keyPair) || this;
        _this.name = name;
        _this.replicationCount = replicationCount;
        _this.storage = storage;
        _this.iconUrl = iconUrl;
        _this.appUrl = appUrl;
        _this.clients = [];
        _this.activeListeners = new Map();
        logger.log('constructor', 'P2PCommunicationClient created');
        _this.KNOWN_RELAY_SERVERS = matrixNodes.length > 0 ? matrixNodes : KNOWN_RELAY_SERVERS;
        return _this;
    }
    P2PCommunicationClient.prototype.getPairingRequestInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var info, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = {};
                        return [4 /*yield*/, generate_uuid_1.generateGUID()];
                    case 1:
                        _a.id = _b.sent(),
                            _a.type = 'p2p-pairing-request',
                            _a.name = this.name,
                            _a.version = constants_1.BEACON_VERSION;
                        return [4 /*yield*/, this.getPublicKey()];
                    case 2:
                        _a.publicKey = _b.sent();
                        return [4 /*yield*/, this.getRelayServer()];
                    case 3:
                        info = (_a.relayServer = _b.sent(),
                            _a);
                        if (this.iconUrl) {
                            info.icon = this.iconUrl;
                        }
                        if (this.appUrl) {
                            info.appUrl = this.appUrl;
                        }
                        return [2 /*return*/, info];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.getPairingResponseInfo = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var info, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = {
                            id: request.id,
                            type: 'p2p-pairing-response',
                            name: this.name,
                            version: constants_1.BEACON_VERSION
                        };
                        return [4 /*yield*/, this.getPublicKey()];
                    case 1:
                        _a.publicKey = _b.sent();
                        return [4 /*yield*/, this.getRelayServer()];
                    case 2:
                        info = (_a.relayServer = _b.sent(),
                            _a);
                        if (this.iconUrl) {
                            info.icon = this.iconUrl;
                        }
                        if (this.appUrl) {
                            info.appUrl = this.appUrl;
                        }
                        return [2 /*return*/, info];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.getRelayServer = function (publicKeyHash, nonce) {
        if (nonce === void 0) { nonce = ''; }
        return __awaiter(this, void 0, void 0, function () {
            var hash, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = publicKeyHash;
                        if (_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, crypto_1.getHexHash(this.keyPair.publicKey)];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        hash = _a;
                        return [2 /*return*/, this.KNOWN_RELAY_SERVERS.reduce(function (prevPromise, curr) { return __awaiter(_this, void 0, void 0, function () {
                                var prev, prevRelayServerHash, currRelayServerHash, prevBigInt, currBigInt;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, prevPromise];
                                        case 1:
                                            prev = _a.sent();
                                            return [4 /*yield*/, crypto_1.getHexHash(prev + nonce)];
                                        case 2:
                                            prevRelayServerHash = _a.sent();
                                            return [4 /*yield*/, crypto_1.getHexHash(curr + nonce)];
                                        case 3:
                                            currRelayServerHash = _a.sent();
                                            return [4 /*yield*/, this.getAbsoluteBigIntDifference(hash, prevRelayServerHash)];
                                        case 4:
                                            prevBigInt = _a.sent();
                                            return [4 /*yield*/, this.getAbsoluteBigIntDifference(hash, currRelayServerHash)];
                                        case 5:
                                            currBigInt = _a.sent();
                                            return [2 /*return*/, prevBigInt.isLessThan(currBigInt) ? prev : curr];
                                    }
                                });
                            }); }, Promise.resolve(this.KNOWN_RELAY_SERVERS[0]))];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var loginRawDigest, rawSignature, _loop_1, this_1, i;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.log('start', 'starting client');
                        return [4 /*yield*/, sodium.ready];
                    case 1:
                        _a.sent();
                        loginRawDigest = sodium.crypto_generichash(32, sodium.from_string("login:" + Math.floor(Date.now() / 1000 / (5 * 60))));
                        rawSignature = sodium.crypto_sign_detached(loginRawDigest, this.keyPair.privateKey);
                        logger.log('start', "connecting to " + this.replicationCount + " servers");
                        _loop_1 = function (i) {
                            var client, _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
                            return __generator(this, function (_r) {
                                switch (_r.label) {
                                    case 0:
                                        _b = (_a = MatrixClient_1.MatrixClient).create;
                                        _c = {};
                                        _d = "https://";
                                        _f = (_e = this_1).getRelayServer;
                                        return [4 /*yield*/, this_1.getPublicKeyHash()];
                                    case 1: return [4 /*yield*/, _f.apply(_e, [_r.sent(), i.toString()])];
                                    case 2:
                                        client = _b.apply(_a, [(_c.baseUrl = _d + (_r.sent()),
                                                _c.storage = this_1.storage,
                                                _c)]);
                                        client.subscribe(MatrixClientEvent_1.MatrixClientEventType.INVITE, function (event) { return __awaiter(_this, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, client.joinRooms(event.content.roomId)];
                                                    case 1:
                                                        _a.sent();
                                                        return [2 /*return*/];
                                                }
                                            });
                                        }); });
                                        _h = (_g = logger).log;
                                        _j = ['start',
                                            'login'];
                                        return [4 /*yield*/, this_1.getPublicKeyHash()];
                                    case 3:
                                        _j = _j.concat([_r.sent(), 'on']);
                                        _l = (_k = this_1).getRelayServer;
                                        return [4 /*yield*/, this_1.getPublicKeyHash()];
                                    case 4: return [4 /*yield*/, _l.apply(_k, [_r.sent(), i.toString()])];
                                    case 5:
                                        _h.apply(_g, _j.concat([_r.sent()]));
                                        _o = (_m = client).start;
                                        _p = {};
                                        return [4 /*yield*/, this_1.getPublicKeyHash()];
                                    case 6:
                                        _p.id = _r.sent();
                                        _q = "ed:" + crypto_1.toHex(rawSignature) + ":";
                                        return [4 /*yield*/, this_1.getPublicKey()];
                                    case 7: return [4 /*yield*/, _o.apply(_m, [(_p.password = _q + (_r.sent()),
                                                _p.deviceId = crypto_1.toHex(this_1.keyPair.publicKey),
                                                _p)])
                                            .catch(function (error) { return logger.log(error); })];
                                    case 8:
                                        _r.sent();
                                        return [4 /*yield*/, client.joinRooms.apply(client, client.invitedRooms).catch(function (error) { return logger.log(error); })];
                                    case 9:
                                        _r.sent();
                                        this_1.clients.push(client);
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < this.replicationCount)) return [3 /*break*/, 5];
                        return [5 /*yield**/, _loop_1(i)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.listenForEncryptedMessage = function (senderPublicKey, messageCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var sharedRx, callbackFunction, _i, _a, client;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.activeListeners.has(senderPublicKey)) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.createCryptoBoxServer(senderPublicKey, this.keyPair.privateKey)];
                    case 1:
                        sharedRx = (_b.sent()).sharedRx;
                        callbackFunction = function (event) { return __awaiter(_this, void 0, void 0, function () {
                            var _a, payload, decryptedMessage, decryptionError_1;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = this.isTextMessage(event.content);
                                        if (!_a) return [3 /*break*/, 2];
                                        return [4 /*yield*/, this.isSender(event, senderPublicKey)];
                                    case 1:
                                        _a = (_b.sent());
                                        _b.label = 2;
                                    case 2:
                                        if (!_a) return [3 /*break*/, 6];
                                        payload = void 0;
                                        try {
                                            payload = Buffer.from(event.content.message.content, 'hex');
                                            // content can be non-hex if it's a connection open request
                                        }
                                        catch (_c) {
                                            /* */
                                        }
                                        if (!(payload &&
                                            payload.length >= sodium.crypto_secretbox_NONCEBYTES + sodium.crypto_secretbox_MACBYTES)) return [3 /*break*/, 6];
                                        _b.label = 3;
                                    case 3:
                                        _b.trys.push([3, 5, , 6]);
                                        return [4 /*yield*/, crypto_1.decryptCryptoboxPayload(payload, sharedRx)
                                            // logger.log(
                                            //   'listenForEncryptedMessage',
                                            //   'encrypted message received',
                                            //   decryptedMessage,
                                            //   await new Serializer().deserialize(decryptedMessage)
                                            // )
                                            // console.log('calculated sender ID', await getSenderId(senderPublicKey))
                                            // TODO: Add check for correct decryption key / sender ID
                                        ];
                                    case 4:
                                        decryptedMessage = _b.sent();
                                        // logger.log(
                                        //   'listenForEncryptedMessage',
                                        //   'encrypted message received',
                                        //   decryptedMessage,
                                        //   await new Serializer().deserialize(decryptedMessage)
                                        // )
                                        // console.log('calculated sender ID', await getSenderId(senderPublicKey))
                                        // TODO: Add check for correct decryption key / sender ID
                                        messageCallback(decryptedMessage);
                                        return [3 /*break*/, 6];
                                    case 5:
                                        decryptionError_1 = _b.sent();
                                        return [3 /*break*/, 6];
                                    case 6: return [2 /*return*/];
                                }
                            });
                        }); };
                        this.activeListeners.set(senderPublicKey, callbackFunction);
                        for (_i = 0, _a = this.clients; _i < _a.length; _i++) {
                            client = _a[_i];
                            client.subscribe(MatrixClientEvent_1.MatrixClientEventType.MESSAGE, callbackFunction);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.unsubscribeFromEncryptedMessage = function (senderPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var listener, _i, _a, client;
            return __generator(this, function (_b) {
                listener = this.activeListeners.get(senderPublicKey);
                if (!listener) {
                    return [2 /*return*/];
                }
                for (_i = 0, _a = this.clients; _i < _a.length; _i++) {
                    client = _a[_i];
                    client.unsubscribe(MatrixClientEvent_1.MatrixClientEventType.MESSAGE, listener);
                }
                this.activeListeners.delete(senderPublicKey);
                return [2 /*return*/];
            });
        });
    };
    P2PCommunicationClient.prototype.unsubscribeFromEncryptedMessages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, client;
            return __generator(this, function (_b) {
                for (_i = 0, _a = this.clients; _i < _a.length; _i++) {
                    client = _a[_i];
                    client.unsubscribe(MatrixClientEvent_1.MatrixClientEventType.MESSAGE);
                }
                this.activeListeners.clear();
                return [2 /*return*/];
            });
        });
    };
    P2PCommunicationClient.prototype.sendMessage = function (message, peer) {
        return __awaiter(this, void 0, void 0, function () {
            var sharedTx, _loop_2, this_2, i;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createCryptoBoxClient(peer.publicKey, this.keyPair.privateKey)];
                    case 1:
                        sharedTx = (_a.sent()).sharedTx;
                        _loop_2 = function (i) {
                            var recipientHash, recipient, _a, _b, _loop_3, _i, _c, client;
                            return __generator(this, function (_d) {
                                switch (_d.label) {
                                    case 0: return [4 /*yield*/, crypto_1.getHexHash(Buffer.from(peer.publicKey, 'hex'))];
                                    case 1:
                                        recipientHash = _d.sent();
                                        _a = crypto_1.recipientString;
                                        _b = [recipientHash];
                                        return [4 /*yield*/, this_2.getRelayServer(recipientHash, i.toString())];
                                    case 2:
                                        recipient = _a.apply(void 0, _b.concat([_d.sent()]));
                                        _loop_3 = function (client) {
                                            var roomId, encryptedMessage;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, this_2.getRelevantRoom(client, recipient)];
                                                    case 1:
                                                        roomId = _a.sent();
                                                        return [4 /*yield*/, crypto_1.encryptCryptoboxPayload(message, sharedTx)
                                                            // logger.log(
                                                            //   'sendMessage',
                                                            //   'sending encrypted message',
                                                            //   peer.publicKey,
                                                            //   roomId,
                                                            //   message,
                                                            //   await new Serializer().deserialize(message)
                                                            // )
                                                        ];
                                                    case 2:
                                                        encryptedMessage = _a.sent();
                                                        // logger.log(
                                                        //   'sendMessage',
                                                        //   'sending encrypted message',
                                                        //   peer.publicKey,
                                                        //   roomId,
                                                        //   message,
                                                        //   await new Serializer().deserialize(message)
                                                        // )
                                                        client.sendTextMessage(roomId, encryptedMessage).catch(function (error) { return __awaiter(_this, void 0, void 0, function () {
                                                            var newRoomId;
                                                            var _this = this;
                                                            return __generator(this, function (_a) {
                                                                switch (_a.label) {
                                                                    case 0:
                                                                        if (!(error.errcode === 'M_FORBIDDEN')) return [3 /*break*/, 3];
                                                                        // Room doesn't exist
                                                                        logger.log("sendMessage", "M_FORBIDDEN", error);
                                                                        return [4 /*yield*/, this.deleteRoomIdFromRooms(roomId)];
                                                                    case 1:
                                                                        _a.sent();
                                                                        return [4 /*yield*/, this.getRelevantRoom(client, recipient)];
                                                                    case 2:
                                                                        newRoomId = _a.sent();
                                                                        client.sendTextMessage(newRoomId, encryptedMessage).catch(function (error2) { return __awaiter(_this, void 0, void 0, function () {
                                                                            return __generator(this, function (_a) {
                                                                                logger.log("sendMessage", "inner error", error2);
                                                                                return [2 /*return*/];
                                                                            });
                                                                        }); });
                                                                        return [3 /*break*/, 4];
                                                                    case 3:
                                                                        logger.log("sendMessage", "not forbidden", error);
                                                                        _a.label = 4;
                                                                    case 4: return [2 /*return*/];
                                                                }
                                                            });
                                                        }); });
                                                        return [2 /*return*/];
                                                }
                                            });
                                        };
                                        _i = 0, _c = this_2.clients;
                                        _d.label = 3;
                                    case 3:
                                        if (!(_i < _c.length)) return [3 /*break*/, 6];
                                        client = _c[_i];
                                        return [5 /*yield**/, _loop_3(client)];
                                    case 4:
                                        _d.sent();
                                        _d.label = 5;
                                    case 5:
                                        _i++;
                                        return [3 /*break*/, 3];
                                    case 6: return [2 /*return*/];
                                }
                            });
                        };
                        this_2 = this;
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < this.replicationCount)) return [3 /*break*/, 5];
                        return [5 /*yield**/, _loop_2(i)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.deleteRoomIdFromRooms = function (roomId) {
        return __awaiter(this, void 0, void 0, function () {
            var roomIds, newRoomIds;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.get(__1.StorageKey.MATRIX_PEER_ROOM_IDS)];
                    case 1:
                        roomIds = _a.sent();
                        newRoomIds = Object.entries(roomIds)
                            .filter(function (entry) { return entry[1] !== roomId; })
                            .reduce(function (pv, cv) {
                            var _a;
                            return (__assign(__assign({}, pv), (_a = {}, _a[cv[0]] = cv[1], _a)));
                        }, {});
                        return [4 /*yield*/, this.storage.set(__1.StorageKey.MATRIX_PEER_ROOM_IDS, newRoomIds)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.listenForChannelOpening = function (messageCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, client;
            var _this = this;
            return __generator(this, function (_b) {
                for (_i = 0, _a = this.clients; _i < _a.length; _i++) {
                    client = _a[_i];
                    client.subscribe(MatrixClientEvent_1.MatrixClientEventType.MESSAGE, function (event) { return __awaiter(_this, void 0, void 0, function () {
                        var _a, splits, payload, pairingResponse, _b, _c, _d, _e, _f, decryptionError_2;
                        return __generator(this, function (_g) {
                            switch (_g.label) {
                                case 0:
                                    _a = this.isTextMessage(event.content);
                                    if (!_a) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.isChannelOpenMessage(event.content)];
                                case 1:
                                    _a = (_g.sent());
                                    _g.label = 2;
                                case 2:
                                    if (!_a) return [3 /*break*/, 7];
                                    logger.log("listenForChannelOpening", "channel opening", JSON.stringify(event));
                                    splits = event.content.message.content.split(':');
                                    payload = Buffer.from(splits[splits.length - 1], 'hex');
                                    if (!(payload.length >=
                                        sodium.crypto_secretbox_NONCEBYTES + sodium.crypto_secretbox_MACBYTES)) return [3 /*break*/, 7];
                                    _g.label = 3;
                                case 3:
                                    _g.trys.push([3, 6, , 7]);
                                    _c = (_b = JSON).parse;
                                    return [4 /*yield*/, crypto_1.openCryptobox(payload, this.keyPair.publicKey, this.keyPair.privateKey)];
                                case 4:
                                    pairingResponse = _c.apply(_b, [_g.sent()]);
                                    _d = messageCallback;
                                    _e = [__assign({}, pairingResponse)];
                                    _f = {};
                                    return [4 /*yield*/, get_sender_id_1.getSenderId(pairingResponse.publicKey)];
                                case 5:
                                    _d.apply(void 0, [__assign.apply(void 0, _e.concat([(_f.senderId = _g.sent(), _f)]))]);
                                    return [3 /*break*/, 7];
                                case 6:
                                    decryptionError_2 = _g.sent();
                                    return [3 /*break*/, 7];
                                case 7: return [2 /*return*/];
                            }
                        });
                    }); });
                }
                return [2 /*return*/];
            });
        });
    };
    P2PCommunicationClient.prototype.sendPairingResponse = function (pairingRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var recipientHash, recipient, _i, _a, client, roomId, message, _b, _c, _d, encryptedMessage;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        logger.log("sendPairingResponse");
                        return [4 /*yield*/, crypto_1.getHexHash(Buffer.from(pairingRequest.publicKey, 'hex'))];
                    case 1:
                        recipientHash = _e.sent();
                        recipient = crypto_1.recipientString(recipientHash, pairingRequest.relayServer);
                        logger.log("sendPairingResponse", "currently there are " + this.clients.length + " clients open");
                        _i = 0, _a = this.clients;
                        _e.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3 /*break*/, 10];
                        client = _a[_i];
                        return [4 /*yield*/, this.getRelevantRoom(client, recipient)
                            // TODO: remove v1 backwards-compatibility
                        ];
                    case 3:
                        roomId = _e.sent();
                        if (!(typeof pairingRequest.version === 'undefined')) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.getPublicKey()]; // v1
                    case 4:
                        _b = _e.sent(); // v1
                        return [3 /*break*/, 7];
                    case 5:
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, this.getPairingResponseInfo(pairingRequest)];
                    case 6:
                        _b = _d.apply(_c, [_e.sent()]); // v2
                        _e.label = 7;
                    case 7:
                        message = _b;
                        return [4 /*yield*/, this.encryptMessageAsymmetric(pairingRequest.publicKey, message)];
                    case 8:
                        encryptedMessage = _e.sent();
                        client
                            .sendTextMessage(roomId, ['@channel-open', recipient, encryptedMessage].join(':'))
                            .catch(function (error) { return logger.log(error); });
                        _e.label = 9;
                    case 9:
                        _i++;
                        return [3 /*break*/, 2];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.isTextMessage = function (content) {
        return content.message.type === MatrixMessage_1.MatrixMessageType.TEXT;
    };
    P2PCommunicationClient.prototype.isChannelOpenMessage = function (content) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        _b = (_a = content.message.content).startsWith;
                        _c = "@channel-open:@";
                        _d = crypto_1.getHexHash;
                        _f = (_e = Buffer).from;
                        return [4 /*yield*/, this.getPublicKey()];
                    case 1: return [4 /*yield*/, _d.apply(void 0, [_f.apply(_e, [_g.sent(), 'hex'])])];
                    case 2: return [2 /*return*/, _b.apply(_a, [_c + (_g.sent())])];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.isSender = function (event, senderPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _b = (_a = event.content.message.sender).startsWith;
                        _c = "@";
                        return [4 /*yield*/, crypto_1.getHexHash(Buffer.from(senderPublicKey, 'hex'))];
                    case 1: return [2 /*return*/, _b.apply(_a, [_c + (_d.sent())])];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.getAbsoluteBigIntDifference = function (firstHash, secondHash) {
        return __awaiter(this, void 0, void 0, function () {
            var difference;
            return __generator(this, function (_a) {
                difference = new bignumber_js_1.default("0x" + firstHash).minus("0x" + secondHash);
                return [2 /*return*/, difference.absoluteValue()];
            });
        });
    };
    P2PCommunicationClient.prototype.getRelevantRoom = function (client, recipient) {
        return __awaiter(this, void 0, void 0, function () {
            var roomIds, roomId, room;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.get(__1.StorageKey.MATRIX_PEER_ROOM_IDS)];
                    case 1:
                        roomIds = _a.sent();
                        roomId = roomIds[recipient];
                        if (!!roomId) return [3 /*break*/, 4];
                        logger.log("getRelevantRoom", "No room found for peer " + recipient + ", checking joined ones.");
                        return [4 /*yield*/, this.getRelevantJoinedRoom(client, recipient)];
                    case 2:
                        room = _a.sent();
                        roomId = room.id;
                        roomIds[recipient] = room.id;
                        return [4 /*yield*/, this.storage.set(__1.StorageKey.MATRIX_PEER_ROOM_IDS, roomIds)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        logger.log("getRelevantRoom", "Using room " + roomId);
                        return [2 /*return*/, roomId];
                }
            });
        });
    };
    P2PCommunicationClient.prototype.getRelevantJoinedRoom = function (client, recipient) {
        return __awaiter(this, void 0, void 0, function () {
            var joinedRooms, relevantRooms, room, roomId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        joinedRooms = client.joinedRooms;
                        relevantRooms = joinedRooms.filter(function (roomElement) {
                            return roomElement.members.some(function (member) { return member === recipient; });
                        });
                        if (!(relevantRooms.length === 0)) return [3 /*break*/, 2];
                        logger.log("getRelevantJoinedRoom", "no relevant rooms found");
                        return [4 /*yield*/, client.createTrustedPrivateRoom(recipient)];
                    case 1:
                        roomId = _a.sent();
                        room = client.getRoomById(roomId);
                        return [3 /*break*/, 3];
                    case 2:
                        room = relevantRooms[0];
                        logger.log("getRelevantJoinedRoom", "channel already open, reusing room " + room.id);
                        _a.label = 3;
                    case 3: return [2 /*return*/, room];
                }
            });
        });
    };
    return P2PCommunicationClient;
}(CommunicationClient_1.CommunicationClient));
exports.P2PCommunicationClient = P2PCommunicationClient;
//# sourceMappingURL=P2PCommunicationClient.js.map