"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.preparePairingAlert = void 0;
var generate_uuid_1 = require("../../utils/generate-uuid");
var Logger_1 = require("../../utils/Logger");
var platform_1 = require("../../utils/platform");
var Alert_1 = require("./Alert");
var Pairing_1 = require("./Pairing");
var logger = new Logger_1.Logger('Alert');
exports.preparePairingAlert = function (shadowRoot, pairingPayload) { return __awaiter(void 0, void 0, void 0, function () {
    var info, container, buttonListWrapper, qr, copyButton, titleEl, platform, mainText, walletList, switchButton, fn, showPlatform_1, showQr_1, switchPlatform, platformSwitch;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, Pairing_1.Pairing.getPairingInfo(pairingPayload, function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, Alert_1.closeAlerts()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); })];
            case 1:
                info = _a.sent();
                container = shadowRoot.getElementById("pairing-container");
                if (!container) {
                    throw new Error('container not found');
                }
                buttonListWrapper = document.createElement('span');
                container.appendChild(buttonListWrapper);
                info.buttons.forEach(function (button) { return __awaiter(void 0, void 0, void 0, function () {
                    var randomId, x, el, buttonEl;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, generate_uuid_1.generateGUID()];
                            case 1:
                                randomId = _a.sent();
                                x = "\n    <div class=\"beacon-list__title\">" + button.title + "</div>\n\t\t<button class=\"beacon-modal__button connect__btn\">" + button.text + "</button>\n\t\t ";
                                el = document.createElement('a');
                                el.id = "button_" + randomId;
                                el.innerHTML = x;
                                buttonListWrapper.appendChild(el);
                                buttonEl = shadowRoot.getElementById(el.id);
                                if (buttonEl) {
                                    buttonEl.addEventListener('click', function () { return __awaiter(void 0, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            button.clickHandler();
                                            return [2 /*return*/];
                                        });
                                    }); });
                                }
                                return [2 /*return*/];
                        }
                    });
                }); });
                info.walletLists.forEach(function (list) {
                    var listWrapperEl = document.createElement('div');
                    container.appendChild(listWrapperEl);
                    var listTitleEl = document.createElement('div');
                    listTitleEl.classList.add('beacon-list__title');
                    listTitleEl.innerHTML = list.title;
                    listWrapperEl.appendChild(listTitleEl);
                    var listEl = document.createElement('span');
                    listWrapperEl.appendChild(listEl);
                    list.wallets.forEach(function (wallet) { return __awaiter(void 0, void 0, void 0, function () {
                        var altTag, randomId, x, el, walletEl;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    altTag = "Open in " + wallet.name;
                                    return [4 /*yield*/, generate_uuid_1.generateGUID()];
                                case 1:
                                    randomId = _a.sent();
                                    x = "\n\t\t\t<a tabindex=\"0\" alt=\"" + altTag + "\" id=\"wallet_" + randomId + "\"\n\t\t\t target=\"_blank\" class=\"beacon-selection__list" + (wallet.enabled ? '' : ' disabled') + "\">\n\t\t\t <div class=\"beacon-selection__name\">" + wallet.name + "\n\t\t\t " + (wallet.enabled ? '' : '<p>Not installed</p>') + "\n\t\t\t </div>\n\t\t\t " + (wallet.logo
                                        ? "<div>\n\t\t\t <img class=\"beacon-selection__img\" src=\"" + wallet.logo + "\"/>\n\t\t\t </div>"
                                        : '<svg class="beacon-selection__img" aria-hidden="true" focusable="false" data-prefix="fas" data-icon="wallet" class="svg-inline--fa fa-wallet fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve"><path d="M376.2,181H152.9c-5.2,0-9.4-4.2-9.4-9.4s4.2-9.4,9.4-9.4h225c5.2,0,9.4-4.2,9.4-9.4c0-15.5-12.6-28.1-28.1-28.1H143.5c-20.7,0-37.5,16.8-37.5,37.5v187.5c0,20.7,16.8,37.5,37.5,37.5h232.7c16.4,0,29.8-12.6,29.8-28.1v-150C406,193.6,392.7,181,376.2,181z M349.8,302.9c-10.4,0-18.8-8.4-18.8-18.8s8.4-18.8,18.8-18.8s18.8,8.4,18.8,18.8S360.1,302.9,349.8,302.9z"/></svg>') + "\n\t\t\t</a>\n\t\t\t ";
                                    el = document.createElement('span');
                                    el.innerHTML = x;
                                    listEl.appendChild(el);
                                    walletEl = shadowRoot.getElementById("wallet_" + randomId);
                                    if (walletEl) {
                                        walletEl.addEventListener('click', function () { return __awaiter(void 0, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                wallet.clickHandler();
                                                return [2 /*return*/];
                                            });
                                        }); });
                                        walletEl.addEventListener('keydown', function (event) { return __awaiter(void 0, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                if (event.key === 'Enter') {
                                                    wallet.clickHandler();
                                                }
                                                return [2 /*return*/];
                                            });
                                        }); });
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                });
                qr = shadowRoot.getElementById("beacon--qr__container");
                copyButton = shadowRoot.getElementById("beacon--qr__copy");
                titleEl = shadowRoot.getElementById("beacon-title");
                platform = platform_1.isAndroid(window) ? 'android' : platform_1.isIOS(window) ? 'ios' : 'desktop';
                mainText = shadowRoot.getElementById("beacon-main-text");
                walletList = shadowRoot.getElementById("pairing-container");
                switchButton = shadowRoot.getElementById("beacon--switch__container");
                if (mainText && walletList && switchButton && copyButton && qr && titleEl) {
                    fn = function () {
                        navigator.clipboard.writeText(pairingPayload ? pairingPayload.p2pSyncCode : '').then(function () {
                            copyButton.innerText = 'Copied';
                            logger.log('Copying to clipboard was successful!');
                        }, function (err) {
                            logger.error('Could not copy text to clipboard: ', err);
                        });
                    };
                    copyButton.addEventListener('click', fn);
                    qr.addEventListener('click', fn);
                    showPlatform_1 = function (type) {
                        var platformSwitch = shadowRoot.getElementById("beacon-switch");
                        if (platformSwitch) {
                            platformSwitch.innerHTML =
                                type === 'none' ? 'Pair Wallet on same device' : 'Pair Wallet on different device';
                        }
                        mainText.style.display = 'none';
                        titleEl.style.textAlign = 'center';
                        walletList.style.display = 'none';
                        switchButton.style.display = 'initial';
                        switch (type) {
                            case 'ios':
                                walletList.style.display = 'initial';
                                break;
                            case 'android':
                                walletList.style.display = 'initial';
                                break;
                            case 'desktop':
                                walletList.style.display = 'initial';
                                titleEl.style.textAlign = 'left';
                                mainText.style.display = 'initial';
                                switchButton.style.display = 'none';
                                break;
                            default:
                                // QR code
                                mainText.style.display = 'initial';
                        }
                    };
                    showQr_1 = false;
                    switchPlatform = function () {
                        showPlatform_1(showQr_1 ? 'none' : platform);
                        showQr_1 = !showQr_1;
                    };
                    switchPlatform();
                    {
                        platformSwitch = shadowRoot.getElementById("beacon-switch");
                        if (platformSwitch) {
                            platformSwitch.addEventListener('click', switchPlatform);
                        }
                    }
                }
                return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=PairingAlert.js.map