"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.openToast = exports.closeToast = void 0;
var colorMode_1 = require("../../colorMode");
var replace_in_template_1 = require("../../utils/replace-in-template");
var generate_uuid_1 = require("../../utils/generate-uuid");
var toast_templates_1 = require("./toast-templates");
var document;
if (typeof window !== 'undefined' && typeof window.document !== 'undefined') {
    document = window.document;
}
var EXPAND_AFTER = 5 * 1000;
var timeout;
var expandTimeout;
var globalToastConfig;
var createActionItem = function (toastAction) { return __awaiter(void 0, void 0, void 0, function () {
    var text, actionText, actionCallback, id, wrapper;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                text = toastAction.text, actionText = toastAction.actionText, actionCallback = toastAction.actionCallback;
                return [4 /*yield*/, generate_uuid_1.generateGUID()];
            case 1:
                id = _a.sent();
                wrapper = document.createElement('div');
                wrapper.classList.add('beacon-toast__action__item');
                if (actionCallback) {
                    wrapper.innerHTML = text.length > 0 ? "<p>" + text + "</p>" : "";
                    wrapper.innerHTML += "<p><a id=\"" + id + "\">" + actionText + "</a></p>";
                }
                else if (actionText) {
                    wrapper.innerHTML =
                        text.length > 0 ? "<p class=\"beacon-toast__action__item__subtitle\">" + text + "</p>" : "";
                    wrapper.innerHTML += "<p>" + actionText + "</p>";
                }
                else {
                    wrapper.innerHTML = "<p>" + text + "</p>";
                }
                if (actionCallback) {
                    wrapper.addEventListener('click', actionCallback);
                }
                return [2 /*return*/, wrapper];
        }
    });
}); };
var removeAllChildNodes = function (parent) {
    while (parent.firstChild) {
        parent.removeChild(parent.firstChild);
    }
};
var formatToastText = function (html) {
    var _a, _b;
    var walletIcon = (_a = globalToastConfig === null || globalToastConfig === void 0 ? void 0 : globalToastConfig.walletInfo) === null || _a === void 0 ? void 0 : _a.icon;
    var walletName = (_b = globalToastConfig === null || globalToastConfig === void 0 ? void 0 : globalToastConfig.walletInfo) === null || _b === void 0 ? void 0 : _b.name;
    var wallet = '';
    if (walletIcon) {
        wallet += "<span class=\"beacon-toast__wallet__container\"><img class=\"beacon-toast__content__img\" src=\"" + walletIcon + "\">";
    }
    if (walletName) {
        wallet += "<strong>" + walletName + "</strong></span>";
    }
    else {
        wallet += "Wallet";
    }
    return replace_in_template_1.replaceInTemplate(html, 'wallet', wallet);
};
var getToastHTML = function (config) {
    var text = config.body;
    var html = replace_in_template_1.replaceInTemplate(toast_templates_1.toastTemplates.default.html, 'text', text);
    html = formatToastText(html);
    return {
        style: toast_templates_1.toastTemplates.default.css,
        html: html
    };
};
/**
 * Close a toast
 */
var closeToast = function () {
    return new Promise(function (resolve) {
        var _a;
        globalToastConfig = undefined;
        var wrapper = document.getElementById('beacon-toast-wrapper');
        if (!wrapper) {
            return resolve();
        }
        var elm = (_a = wrapper.shadowRoot) === null || _a === void 0 ? void 0 : _a.getElementById('beacon-toast');
        if (elm) {
            var animationDuration = 300;
            if (timeout) {
                clearTimeout(timeout);
                timeout = undefined;
            }
            elm.className = elm.className.replace('fadeIn', 'fadeOut');
            window.setTimeout(function () {
                var parent = wrapper.parentNode;
                if (parent) {
                    parent.removeChild(wrapper);
                }
                resolve();
            }, animationDuration);
        }
        else {
            resolve();
        }
    });
};
exports.closeToast = closeToast;
var registerClick = function (shadowRoot, id, callback) {
    var button = shadowRoot.getElementById(id);
    if (button) {
        button.addEventListener('click', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, callback(button)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    }
    return button;
};
var showElement = function (shadowRoot, id) {
    var el = shadowRoot.getElementById(id);
    if (el) {
        el.classList.remove('hide');
        el.classList.add('show');
    }
};
var hideElement = function (shadowRoot, id) {
    var el = shadowRoot.getElementById(id);
    if (el) {
        el.classList.add('hide');
        el.classList.remove('show');
    }
};
// const showLoader = (): void => {
//   showElement('beacon-toast-loader')
// }
var hideLoader = function (shadowRoot) {
    hideElement(shadowRoot, 'beacon-toast-loader');
    showElement(shadowRoot, 'beacon-toast-loader-placeholder');
};
// const showToggle = (): void => {
//   showElement('beacon-toast-button-expand')
//   hideElement('beacon-toast-button-close')
// }
var showClose = function (shadowRoot) {
    showElement(shadowRoot, 'beacon-toast-button-close');
    hideElement(shadowRoot, 'beacon-toast-button-expand');
};
var collapseList = function (shadowRoot) {
    var expandButton = shadowRoot.getElementById('beacon-toast-button-expand');
    var list = shadowRoot.getElementById('beacon-toast-list');
    if (expandButton && list) {
        expandButton.classList.remove('beacon-toast__upside_down');
        list.classList.add('hide');
        list.classList.remove('show');
    }
};
var expandList = function (shadowRoot) {
    var expandButton = shadowRoot.getElementById('beacon-toast-button-expand');
    var list = shadowRoot.getElementById('beacon-toast-list');
    if (expandButton && list) {
        expandButton.classList.add('beacon-toast__upside_down');
        list.classList.remove('hide');
        list.classList.add('show');
    }
};
var expandOrCollapseList = function (shadowRoot) {
    var expandButton = shadowRoot.getElementById('beacon-toast-button-expand');
    var list = shadowRoot.getElementById('beacon-toast-list');
    if (expandButton && list) {
        if (expandButton.classList.contains('beacon-toast__upside_down')) {
            collapseList(shadowRoot);
        }
        else {
            expandList(shadowRoot);
        }
    }
};
var addActionsToToast = function (shadowRoot, toastConfig, list) { return __awaiter(void 0, void 0, void 0, function () {
    var actions, actionPromises, actionItems, poweredByBeacon;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                actions = toastConfig.actions;
                if (!(actions && actions.length > 0)) return [3 /*break*/, 2];
                actionPromises = actions.map(function (action) { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        // eslint-disable-next-line @typescript-eslint/unbound-method
                        return [2 /*return*/, createActionItem(action)];
                    });
                }); });
                return [4 /*yield*/, Promise.all(actionPromises)];
            case 1:
                actionItems = _a.sent();
                actionItems.forEach(function (item) { return list.appendChild(item); });
                poweredByBeacon = document.createElement('small');
                poweredByBeacon.classList.add('beacon-toast__powered');
                poweredByBeacon.innerHTML = toast_templates_1.toastTemplates.default.poweredByBeacon;
                list.appendChild(poweredByBeacon);
                return [3 /*break*/, 3];
            case 2:
                showClose(shadowRoot);
                collapseList(shadowRoot);
                _a.label = 3;
            case 3: return [2 /*return*/];
        }
    });
}); };
var createNewToast = function (toastConfig) { return __awaiter(void 0, void 0, void 0, function () {
    var timer, shadowRootEl, shadowRoot, wrapper, _a, style, html, styleEl, colorMode, elm, list, closeButton;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                globalToastConfig = toastConfig;
                timer = toastConfig.timer;
                shadowRootEl = document.createElement('div');
                shadowRootEl.setAttribute('id', 'beacon-toast-wrapper');
                shadowRoot = shadowRootEl.attachShadow({ mode: 'open' });
                wrapper = document.createElement('div');
                _a = getToastHTML(toastConfig), style = _a.style, html = _a.html;
                wrapper.innerHTML = html;
                styleEl = document.createElement('style');
                styleEl.textContent = style;
                shadowRoot.appendChild(wrapper);
                shadowRoot.appendChild(styleEl);
                if (timer) {
                    timeout = window.setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, closeToast()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }, timer);
                }
                document.body.prepend(shadowRootEl);
                colorMode = colorMode_1.getColorMode();
                elm = shadowRoot.getElementById("beacon-toast");
                if (elm) {
                    elm.classList.add("theme__" + colorMode);
                }
                list = shadowRoot.getElementById('beacon-toast-list');
                if (!list) return [3 /*break*/, 2];
                return [4 /*yield*/, addActionsToToast(shadowRoot, toastConfig, list)];
            case 1:
                _b.sent();
                _b.label = 2;
            case 2:
                if (globalToastConfig.state === 'loading') {
                    expandTimeout = window.setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
                        var expandButton;
                        return __generator(this, function (_a) {
                            expandButton = shadowRoot.getElementById('beacon-toast-button-expand');
                            if (expandButton && !expandButton.classList.contains('beacon-toast__upside_down')) {
                                expandOrCollapseList(shadowRoot);
                            }
                            return [2 /*return*/];
                        });
                    }); }, EXPAND_AFTER);
                }
                registerClick(shadowRoot, 'beacon-toast-button-done', function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, closeToast()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); });
                closeButton = registerClick(shadowRoot, 'beacon-toast-button-close', function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, closeToast()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); });
                if (closeButton && globalToastConfig.state === 'loading') {
                    closeButton.classList.add('hide');
                }
                registerClick(shadowRoot, 'beacon-toast-button-expand', function () { return __awaiter(void 0, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        expandOrCollapseList(shadowRoot);
                        return [2 /*return*/];
                    });
                }); });
                return [2 /*return*/];
        }
    });
}); };
var updateToast = function (toastConfig) { return __awaiter(void 0, void 0, void 0, function () {
    var timer, wrapper, shadowRoot, list, toastTextEl, doneButton;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                globalToastConfig = __assign(__assign({}, globalToastConfig), toastConfig);
                timer = toastConfig.timer;
                wrapper = document.getElementById('beacon-toast-wrapper');
                if (!wrapper) {
                    return [2 /*return*/];
                }
                shadowRoot = wrapper.shadowRoot;
                if (!shadowRoot) {
                    return [2 /*return*/];
                }
                list = shadowRoot.getElementById('beacon-toast-list');
                if (!list) return [3 /*break*/, 2];
                removeAllChildNodes(list);
                return [4 /*yield*/, addActionsToToast(shadowRoot, toastConfig, list)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                toastTextEl = shadowRoot.getElementById('beacon-text');
                if (toastTextEl) {
                    toastTextEl.innerHTML = formatToastText(toastConfig.body);
                }
                if (timer) {
                    timeout = window.setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, closeToast()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }, timer);
                }
                doneButton = shadowRoot.getElementById('beacon-toast-button-done');
                if (doneButton) {
                    doneButton.addEventListener('click', function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, closeToast()];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                }
                return [2 /*return*/];
        }
    });
}); };
/**
 * Create a new toast
 *
 * @param toastConfig Configuration of the toast
 */
var openToast = function (toastConfig) { return __awaiter(void 0, void 0, void 0, function () {
    var wrapper, shadowRoot;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (expandTimeout) {
                    clearTimeout(expandTimeout);
                }
                wrapper = document.getElementById('beacon-toast-wrapper');
                if (!wrapper) return [3 /*break*/, 6];
                if (!toastConfig.forceNew) return [3 /*break*/, 3];
                return [4 /*yield*/, closeToast()];
            case 1:
                _b.sent();
                return [4 /*yield*/, createNewToast(toastConfig)];
            case 2:
                _b.sent();
                return [3 /*break*/, 5];
            case 3: return [4 /*yield*/, updateToast(toastConfig)];
            case 4:
                _b.sent();
                _b.label = 5;
            case 5: return [3 /*break*/, 8];
            case 6: return [4 /*yield*/, createNewToast(toastConfig)];
            case 7:
                _b.sent();
                _b.label = 8;
            case 8:
                if (globalToastConfig && globalToastConfig.state === 'finished') {
                    shadowRoot = (_a = document.getElementById('beacon-toast-wrapper')) === null || _a === void 0 ? void 0 : _a.shadowRoot;
                    if (shadowRoot) {
                        hideLoader(shadowRoot);
                        showClose(shadowRoot);
                        expandList(shadowRoot);
                    }
                }
                return [2 /*return*/];
        }
    });
}); };
exports.openToast = openToast;
//# sourceMappingURL=Toast.js.map