import { BeaconEvent, DAppClient, PermissionScope, defaultEventCallbacks } from '..'; // Replace '..' with '@airgap/beacon-sdk'
const client = new DAppClient({
    name: 'My Sample DApp',
    disableDefaultEvents: true,
    eventHandlers: {
        // To keep the pairing alert, we have to add the following default event handlers back
        [BeaconEvent.PAIR_INIT]: {
            handler: defaultEventCallbacks.PAIR_INIT
        },
        [BeaconEvent.PAIR_SUCCESS]: {
            handler: defaultEventCallbacks.PAIR_SUCCESS
        }
    }
});
const scopes = [
    PermissionScope.OPERATION_REQUEST,
    PermissionScope.SIGN,
    PermissionScope.THRESHOLD
];
client
    .requestPermissions({
    scopes
})
    .then((permissionResponse) => {
    console.log('permissions', permissionResponse);
})
    .catch((permissionError) => console.error(permissionError));
//# sourceMappingURL=disable-all-ui.js.map