import { isTextMessageEvent } from '../utils/events';
export var MatrixMessageType;
(function (MatrixMessageType) {
    MatrixMessageType["TEXT"] = "m.text";
})(MatrixMessageType || (MatrixMessageType = {}));
export class MatrixMessage {
    constructor(type, sender, content) {
        this.type = type;
        this.sender = sender;
        this.content = content;
    }
    /**
     * Construct a message from a message event
     *
     * @param event
     */
    static from(event) {
        if (isTextMessageEvent(event)) {
            return new MatrixMessage(event.content.msgtype, event.sender, event.content.body);
        }
        // for now only text messages are supported
        return undefined;
    }
}
//# sourceMappingURL=MatrixMessage.js.map