import * as sodium from 'libsodium-wrappers';
import { PostMessagePairingRequest } from '../types/PostMessagePairingRequest';
import { ExtendedPostMessagePairingResponse } from '../types/PostMessagePairingResponse';
import { Extension } from '../types/Extension';
import { StorageKey } from '../types/storage/StorageKey';
import { TransportType } from '../types/transport/TransportType';
import { Storage } from '../storage/Storage';
import { PostMessageClient } from './clients/PostMessageClient';
import { Transport } from './Transport';
export declare class PostMessageTransport<T extends PostMessagePairingRequest | ExtendedPostMessagePairingResponse, K extends StorageKey.TRANSPORT_POSTMESSAGE_PEERS_DAPP | StorageKey.TRANSPORT_POSTMESSAGE_PEERS_WALLET> extends Transport<T, K, PostMessageClient> {
    readonly type: TransportType;
    constructor(name: string, keyPair: sodium.KeyPair, storage: Storage, storageKey: K);
    static isAvailable(): Promise<boolean>;
    static getAvailableExtensions(): Promise<Extension[]>;
    connect(): Promise<void>;
    startOpenChannelListener(): Promise<void>;
    getPairingRequestInfo(): Promise<PostMessagePairingRequest>;
    listen(publicKey: string): Promise<void>;
}
